# Exoscale Documentation — Exoscale API

> Infrastructure automation API, allowing programmatic access to all Exoscale products and services.

---

url: https://community.exoscale.com/reference/api/

---

# Exoscale API

Infrastructure automation API, allowing programmatic access to all Exoscale products and services.

[OpenAPI Specification (YAML)](exoscale-openapi-spec.yaml) | [JSON](exoscale-openapi-spec.json)

**Last updated:** October 14, 2026

- [Compute](https://community.exoscale.com/reference/api/compute/index.md) - Host anything from simple applications to complex architectures. Start a compute instance in seconds and scale as your infrastructure grows.
- [Networking](https://community.exoscale.com/reference/api/networking/index.md) - Networking services for Exoscale resources, including Virtual Private Cloud (VPC).
- [SKS](https://community.exoscale.com/reference/api/sks/index.md) - SKS is Exoscale's scalable Kubernetes service which provides managed Kubernetes control planes with integrated support for Exoscale instance pools and network load balancers.
- [DBaaS](https://community.exoscale.com/reference/api/dbaas/index.md) - Databases as a Service (DBaaS) provides scalable and fully-managed database solutions with high availability and performance backed by Exoscale's Compute and Storage services.
- [Object Storage](https://community.exoscale.com/reference/api/object-storage/index.md) - Exoscale Simple Object Storage (SOS) is an S3-compatible object storage service.
- [Block Storage](https://community.exoscale.com/reference/api/block-storage/index.md) - Exoscale's Block Storage offers persistent externally attached volumes for your Compute instances.
- [DNS](https://community.exoscale.com/reference/api/dns/index.md) - DNS zone hosting and records management.
- [IAM](https://community.exoscale.com/reference/api/iam/index.md) - Identity and Access Management: roles, users, policies and credentials for accessing the Exoscale API.
- [AI](https://community.exoscale.com/reference/api/ai/index.md) - Exoscale AI services provide GPU-powered infrastructure for running machine learning workloads and large language models.
- [Audit Trail](https://community.exoscale.com/reference/api/audit-trail/index.md) - The Exoscale audit-trail provides a mechanism to query past events performing mutations on resources which happened on an organization.
- [KMS](https://community.exoscale.com/reference/api/kms/index.md) - Exoscale Key Management Service is a managed security service that lets you create, control and manage the lifecycle of cryptographic keys.
- [General](https://community.exoscale.com/reference/api/general/index.md) - 11 API operations

## API Request Signature


In order to authenticate legitimate users, the Exoscale API requires incoming requests to be signed using valid Exoscale API account credentials with the following mechanism.

## Signature Mechanism

The *message* (i.e. content) to sign contains several segments concatenated using a line return character (`\n`).

All segments must be included and in the described order. For cases where a segment doesn't fit the context of the request (e.g. no request body) **an empty line must be used instead**.

* Request method and request URL (path only), separated by a space character
* Request body
* Request URL parameters (Query String) values, concatenated without separator. The matching parameter names have to be specified in the resulting signature header `signed-query-args=` pragma, separated by semicolons (e.g. `p1;p2;pN`).
* Request header values, concatenated without separator (none at the moment, leave empty)
* Request expiration date in UNIX timestamp format

Example *message* to sign for `GET /v2/resource/a02baf5a-a3e4-49a0-857b-8a08d276c1c0?p1=v1&p2=v2`:

```
GET /v2/resource/a02baf5a-a3e4-49a0-857b-8a08d276c1c0

v1v2

1599140767
```

The two blank lines above are due to the absence of a request body and signed headers.

Example *message* to [create a security group](https://community.exoscale.com/reference/api/compute/security-group/index.md#create-security-group)

```
POST /v2/security-group
{"name": "my-security-group"}


1599140767
```

The two blank lines above are due to the absence of query parameters and signed headers.

The request signature consists of the base64-encoded [HMAC](https://en.wikipedia.org/wiki/HMAC) hash of the UTF-8 encoded *message* and the Exoscale API secret using the SHA256 function:

```
signature = BASE64_ENCODE(HMAC_SHA256(Exoscale API secret, message))
```

Finally, the computed signature must be added to the API request in an `Authorization` header such as:

```
Authorization: EXO2-HMAC-SHA256 credential=<Exoscale API key>,expires=<expiration date UNIX timestamp>,signature=<signature>
```

Example API query:

```
GET /v2/resource/a02baf5a-a3e4-49a0-857b-8a08d276c1c0?p1=v1&p2=v2 HTTP/1.1
Host: api-ch-gva-2.exoscale.com
Authorization: EXO2-HMAC-SHA256 credential=EXO29147e9f89102b7ac1e88514,signed-query-args=p1;p2,expires=1599140767,signature=2AOBQsbElQb4FpKT/FM/9T4NobjlmZkSGvvdUth/xlY=
```

## Reference Implementations

You can look up the following existing reference implementations:

* Go: [github.com/exoscale/egoscale/api/v2 > `SecurityProviderExoscale.signRequest`](https://github.com/exoscale/egoscale/blob/master/v2/api/security.go)
* Python: [requests-exoscale-auth > `ExoscaleV2Auth`](https://github.com/exoscale/requests-exoscale-auth/blob/master/exoscale_auth.py)



## Zone local resources


The API is deployed across all Exoscale zones. When performing a compute call, you should use the relevant zone for your resource.
For example: https://api-de-fra-1.exoscale.com/v2/instance would return only the instances from `de-fra-1`, https://api-ch-gva-2.exoscale.com/v2/instance from `ch-gva-2`.
To obtain a list of all instances across all zones, you would need to do the corresponding request for each zone.

---

url: https://community.exoscale.com/reference/api/compute/

---

# Compute

Host anything from simple applications to complex architectures. Start a compute instance in seconds and scale as your infrastructure grows.

[Read more](https://community.exoscale.com/product/compute/index.md)

- [Instance](https://community.exoscale.com/reference/api/compute/instance/index.md) - Instances are the virtual machines at the core of the Exoscale Compute service.
- [Instance Pool](https://community.exoscale.com/reference/api/compute/instance-pool/index.md) - Instance Pools is an Exoscale service allowing users to provision managed groups of identical Compute instances automatically.
- [Snapshot](https://community.exoscale.com/reference/api/compute/snapshot/index.md) - Snapshots provide a way to get point-in-time recovery for your Compute instance.
- [Template](https://community.exoscale.com/reference/api/compute/template/index.md) - Templates contain the OS and the initial setup of a Compute instance.
- [Security Group](https://community.exoscale.com/reference/api/compute/security-group/index.md) - Security Groups are groups of firewall rules that regulate network traffic to and from your Compute instances.
- [SSH Key](https://community.exoscale.com/reference/api/compute/ssh-key/index.md) - SSH Keypairs
- [Elastic IP](https://community.exoscale.com/reference/api/compute/elastic-ip/index.md) - Elastic IPs are additional public IPv4/6 addresses that can be attached to Compute instances, with optional healthcheck support.
- [Network Load Balancer](https://community.exoscale.com/reference/api/compute/network-load-balancer/index.md) - A Network Load Balancer (NLB) is a Layer 4 (TCP/UDP) load balancer that distributes incoming traffic to Compute instances managed by an Instance Pool.
- [Private Network](https://community.exoscale.com/reference/api/compute/private-network/index.md) - Private Network provides private L2 networking functionality between Compute instances.
- [Instance Type](https://community.exoscale.com/reference/api/compute/instance-type/index.md) - An Instance Type is a resource describing the amount of CPU, RAM and GPUs allocated to a Compute instance.
- [Reverse DNS](https://community.exoscale.com/reference/api/compute/reverse-dns/index.md) - Reverse DNS lets you record PTR records for Compute instance public IP addresses or Elastic IPs.
- [Anti-Affinity Group](https://community.exoscale.com/reference/api/compute/anti-affinity-group/index.md) - Anti-affinity groups let you define placement constraints for your Compute instances.
- [Deploy Target](https://community.exoscale.com/reference/api/compute/deploy-target/index.md) - Deploy Target lets you spin up Compute instances on dedicated hypervisors.

---

url: https://community.exoscale.com/reference/api/compute/instance/

---

# Instance

<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Instances are the virtual machines at the core of the Exoscale Compute service.

[Read more](https://www.exoscale.com/compute/)

## <span data-label="POST" class="pill-POST"></span>create-instance

Create a Compute instance

```
POST /instance
```

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `disk-size` | integer | **yes** | Instance disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `instance-type` | [Instance type reference](https://community.exoscale.com/reference/api/_schemas/instance-type-ref/index.md) | **yes** | Instance Type |
| `template` | [Template reference](https://community.exoscale.com/reference/api/_schemas/template-ref/index.md) | **yes** | Instance Template |
| `anti-affinity-groups` | array of [Anti-affinity group reference](https://community.exoscale.com/reference/api/_schemas/anti-affinity-group-ref/index.md) | no | Instance Anti-affinity Groups |
| `application-consistent-snapshot-enabled` | boolean | no | Enable application-consistent snapshot for the instance |
| `auto-start` | boolean | no | Start Instance on creation (default: true) |
| `deploy-target` | [Deploy target reference](https://community.exoscale.com/reference/api/_schemas/deploy-target-ref/index.md) | no | Instance Deploy Target |
| `ip-forwarding` | boolean | no | VPC ip forwarding |
| `ipv6-enabled` | boolean | no | Enable IPv6. DEPRECATED: use `public-ip-assignments`. |
| `labels` | object | no | Resource labels |
| `name` | string | no | Instance name<br/><br/>Min length: `1`. Max length: `255`. |
| `public-ip-assignment` | string | no | Assign public IP to the Instance<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `secureboot-enabled` | boolean | no | Enable secure boot |
| `security-groups` | array of [Security group reference](https://community.exoscale.com/reference/api/_schemas/security-group-ref/index.md) | no | Instance Security Groups |
| `ssh-key` | [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instance SSH Key |
| `ssh-keys` | array of [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instance SSH Keys |
| `tpm-enabled` | boolean | no | Enable Trusted Platform Module (TPM) |
| `user-data` | string | no | Instance Cloud-init user-data (base64 encoded)<br/><br/>Min length: `1`. Max length: `32768`. |
| `vpc` | [Vpc](#vpc) | no | Attach the Instance to VPC Subnets |

<details>
<summary>Example</summary>

```json
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "auto-start": true,
  "deploy-target": {
    "id": "string"
  },
  "disk-size": 0,
  "instance-type": {
    "id": "string"
  },
  "ip-forwarding": true,
  "ipv6-enabled": true,
  "labels": {},
  "name": "string",
  "public-ip-assignment": "inet4",
  "secureboot-enabled": true,
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "template": {
    "id": "string"
  },
  "tpm-enabled": true,
  "user-data": "string",
  "vpc": {
    "id": "string",
    "subnets": [
      {
        "id": "string",
        "ipv4": "string"
      }
    ]
  }
}
```
</details>


### Vpc {#vpc}

Attach the Instance to VPC Subnets

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `id` | string | **yes** | VPC ID<br/><br/>Must be a valid UUID. |
| `subnets` | array of [Subnets](#subnets) | **yes** | VPC Subnets to attach the Instance to |

### Subnets {#subnets}

VPC Subnet attachment

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `id` | string | **yes** | Subnet ID<br/><br/>Must be a valid UUID. |
| `ipv4` | string | no | Instance IPv4. Random one if unset<br/><br/>Must be a valid IPv4 address. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createInstance(com.exoscale.sdk.model.CreateInstanceRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api create-instance`

## <span data-label="GET" class="pill-GET"></span>get-instance

Retrieve Compute instance details

```
GET /instance/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `anti-affinity-groups` | array of [Anti-affinity group reference](https://community.exoscale.com/reference/api/_schemas/anti-affinity-group-ref/index.md) | Instance Anti-affinity Groups |
| `application-consistent-snapshot-enabled` | boolean | Indicates if the instance will take application-consistent snapshots |
| `created-at` | string | Instance creation date<br/><br/>ISO 8601 date-time. |
| `deploy-target` | [Deploy target reference](https://community.exoscale.com/reference/api/_schemas/deploy-target-ref/index.md) | Instance Deploy Target |
| `disk-encrypted` | boolean | Indicates if the root volume of the instance is encrypted |
| `disk-size` | integer | Instance disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `elastic-ips` | array of [Elastic IP reference](https://community.exoscale.com/reference/api/_schemas/elastic-ip-ref/index.md) | Instance Elastic IPs |
| `id` | string | Instance ID<br/><br/>Must be a valid UUID. |
| `instance-type` | [Compute instance type](https://community.exoscale.com/reference/api/_schemas/instance-type/index.md) | Instance Type |
| `ip-forwarding` | boolean | VPC ip forwarding |
| `ipv6-address` | string | Instance IPv6 address |
| `labels` | object | Resource labels |
| `mac-address` | string | Instance MAC address |
| `manager` | [Resource manager](https://community.exoscale.com/reference/api/_schemas/manager/index.md) | Instance manager |
| `name` | string | Instance name<br/><br/>Min length: `1`. Max length: `255`. |
| `private-networks` | array of [Private Networks](https://community.exoscale.com/reference/api/_schemas/instance/index.md#private-networks) | Instance Private Networks |
| `public-ip` | string | Instance public IPv4 address<br/><br/>Must be a valid IPv4 address. |
| `public-ip-assignment` | string | Instance public IP assignment<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `secureboot-enabled` | boolean | Indicates if the instance has secure boot enabled |
| `security-groups` | array of [Security group reference](https://community.exoscale.com/reference/api/_schemas/security-group-ref/index.md) | Instance Security Groups |
| `snapshots` | array of [Snapshot reference](https://community.exoscale.com/reference/api/_schemas/snapshot-ref/index.md) | Instance Snapshots |
| `ssh-key` | [SSH key](https://community.exoscale.com/reference/api/_schemas/ssh-key/index.md) | Instance SSH Key |
| `ssh-keys` | array of [SSH key](https://community.exoscale.com/reference/api/_schemas/ssh-key/index.md) | Instance SSH Keys |
| `state` | string | Instance state<br/><br/>Allowed values: `expunging`, `starting`, `destroying`, `running`, `stopping`, `stopped`, `migrating`, `error`, `destroyed`. |
| `template` | [Instance template](https://community.exoscale.com/reference/api/_schemas/template/index.md) | Instance Template |
| `tpm-enabled` | boolean | Indicates if the instance has tpm enabled |
| `user-data` | string | Instance Cloud-init user-data (base64 encoded)<br/><br/>Min length: `1`. |
| `vpc` | [Vpc](https://community.exoscale.com/reference/api/_schemas/instance/index.md#vpc) | VPC |

<details>
<summary>Example output</summary>

```json
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "created-at": "2024-01-01T12:00:00Z",
  "deploy-target": {
    "id": "string"
  },
  "disk-encrypted": true,
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "id": "string",
  "instance-type": {
    "authorized": true,
    "cpus": 0,
    "family": "gpu3",
    "gpus": 0,
    "id": "string",
    "memory": 0,
    "size": "large",
    "zones": [
      "ch-dk-2"
    ]
  },
  "ip-forwarding": true,
  "ipv6-address": "string",
  "labels": {},
  "mac-address": "string",
  "manager": {
    "id": "string",
    "type": "sks-nodepool"
  },
  "name": "string",
  "private-networks": [
    {
      "id": "string",
      "mac-address": "string"
    }
  ],
  "public-ip": "string",
  "public-ip-assignment": "inet4",
  "secureboot-enabled": true,
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "snapshots": [
    {
      "id": "string"
    }
  ],
  "ssh-key": {
    "fingerprint": "string",
    "name": "string"
  },
  "ssh-keys": [
    {
      "fingerprint": "string",
      "name": "string"
    }
  ],
  "state": "expunging",
  "template": {
    "application-consistent-snapshot-enabled": true,
    "boot-mode": "legacy",
    "build": "string",
    "checksum": "string",
    "created-at": "2024-01-01T12:00:00Z",
    "default-user": "string",
    "description": "string",
    "family": "string",
    "id": "string",
    "maintainer": "string",
    "name": "string",
    "password-enabled": true,
    "size": 0,
    "ssh-key-enabled": true,
    "url": "string",
    "version": "string",
    "visibility": "private"
  },
  "tpm-enabled": true,
  "user-data": "string",
  "vpc": {
    "id": "string",
    "name": "string",
    "subnets": [
      {
        "id": "string",
        "ipv4": "string",
        "name": "string"
      }
    ]
  }
}
```
</details>


SDK reference for `get-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getInstance(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api get-instance`

## <span data-label="PUT" class="pill-PUT"></span>reset-instance

Reset a Compute instance to a base/target template

```
PUT /instance/{id}:reset
```

This operation re-installs a Compute instance to a base template. If target template is provided it will be used to recreated instance from. Warning: the operation wipes all data stored on the disk.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `disk-size` | integer | no | Instance disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `template` | [Template reference](https://community.exoscale.com/reference/api/_schemas/template-ref/index.md) | no | Template to recreate Instance from |

<details>
<summary>Example</summary>

```json
{
  "disk-size": 0,
  "template": {
    "id": "string"
  }
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reset-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetInstance(java.util.UUID,com.exoscale.sdk.model.ResetInstanceRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reset-instance`

## <span data-label="PUT" class="pill-PUT"></span>start-instance

Start a Compute instance

```
PUT /instance/{id}:start
```

This operation starts a virtual machine, potentially using a rescue profile if specified

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `rescue-profile` | string | no | Boot in Rescue Mode, using named profile (supported: netboot, netboot-efi)<br/><br/>Allowed values: `netboot-efi`, `netboot`. |

<details>
<summary>Example</summary>

```json
{
  "rescue-profile": "netboot-efi"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `start-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.StartInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.start_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#startInstance(java.util.UUID,com.exoscale.sdk.model.StartInstanceRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api start-instance`

## <span data-label="PUT" class="pill-PUT"></span>scale-instance

Scale a Compute instance to a new Instance Type

```
PUT /instance/{id}:scale
```

This operation changes the Compute instance's type. Note: the new Instance Type must be within the same family (e.g. a standard instance cannot be scaled to gpu2 or storage).

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `instance-type` | [Instance type reference](https://community.exoscale.com/reference/api/_schemas/instance-type-ref/index.md) | **yes** | Instance Type |

<details>
<summary>Example</summary>

```json
{
  "instance-type": {
    "id": "string"
  }
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `scale-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ScaleInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.scale_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#scaleInstance(java.util.UUID,com.exoscale.sdk.model.ScaleInstanceRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api scale-instance`

## <span data-label="PUT" class="pill-PUT"></span>stop-instance

Stop a Compute instance

```
PUT /instance/{id}:stop
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `stop-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.StopInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.stop_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#stopInstance(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api stop-instance`

## <span data-label="PUT" class="pill-PUT"></span>reboot-instance

Reboot a Compute instance

```
PUT /instance/{id}:reboot
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reboot-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RebootInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reboot_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#rebootInstance(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reboot-instance`

## <span data-label="PUT" class="pill-PUT"></span>update-instance

Update a Compute instance

```
PUT /instance/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `application-consistent-snapshot-enabled` | boolean | no | Enable/Disable Application Consistent Snapshot for Instance |
| `labels` | object | no | Resource labels |
| `name` | string | no | Instance name<br/><br/>Min length: `1`. Max length: `255`. |
| `public-ip-assignment` | string | no | Assign public IP to the Instance<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `user-data` | string | no | Instance Cloud-init user-data (base64 encoded)<br/><br/>Min length: `1`. Max length: `32768`. |

<details>
<summary>Example</summary>

```json
{
  "application-consistent-snapshot-enabled": true,
  "labels": {},
  "name": "string",
  "public-ip-assignment": "inet4",
  "user-data": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `update-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.UpdateInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.update_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#updateInstance(java.util.UUID,com.exoscale.sdk.model.UpdateInstanceRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api update-instance`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-instance

Delete a Compute instance

```
DELETE /instance/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-instance`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteInstance) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_instance) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteInstance(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api delete-instance`

## <span data-label="GET" class="pill-GET"></span>reveal-instance-password

Reveal the password used during instance creation or the latest password reset.

```
GET /instance/{id}:password
```

Reveal the password used during instance creation or the latest password reset.
            This is only available for VMs created against templates having the `password-enabled`
            property set to `true`.

            Passwords are transiently stored for at most 24 hours and intended to be retrieved shortly after
            creation or resets.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `password` | string | Password |

<details>
<summary>Example output</summary>

```json
{
  "password": "string"
}
```
</details>


SDK reference for `reveal-instance-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RevealInstancePassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reveal_instance_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#revealInstancePassword(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reveal-instance-password`

## <span data-label="PUT" class="pill-PUT"></span>reset-instance-password

Reset a compute instance password

```
PUT /instance/{id}:reset-password
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reset-instance-password`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetInstancePassword) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_instance_password) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetInstancePassword(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reset-instance-password`

## <span data-label="PUT" class="pill-PUT"></span>remove-instance-protection

Remove instance destruction protection

```
PUT /instance/{id}:remove-protection
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `remove-instance-protection`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RemoveInstanceProtection) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.remove_instance_protection) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#removeInstanceProtection(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api remove-instance-protection`

## <span data-label="PUT" class="pill-PUT"></span>add-instance-protection

Set instance destruction protection

```
PUT /instance/{id}:add-protection
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `add-instance-protection`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.AddInstanceProtection) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.add_instance_protection) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#addInstanceProtection(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api add-instance-protection`


---

## Other Operations

## <span data-label="GET" class="pill-GET"></span>get-console-proxy-url

Retrieve signed url valid for 60 seconds to connect via console-proxy websocket to VM VNC console.

```
GET /console/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `host` | string |  |
| `path` | string |  |
| `url` | string |  |

<details>
<summary>Example output</summary>

```json
{
  "host": "string",
  "path": "string",
  "url": "string"
}
```
</details>


SDK reference for `get-console-proxy-url`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetConsoleProxyURL) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_console_proxy_url) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getConsoleProxyUrl(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api get-console-proxy-url`

## <span data-label="PUT" class="pill-PUT"></span>resize-instance-disk

Resize a Compute instance disk

```
PUT /instance/{id}:resize-disk
```

This operation resizes a Compute instance's disk volume. Note: the disk can only grow, cannot be shrunk.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `disk-size` | integer | **yes** | Instance disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |

<details>
<summary>Example</summary>

```json
{
  "disk-size": 0
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `resize-instance-disk`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResizeInstanceDisk) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.resize_instance_disk) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resizeInstanceDisk(java.util.UUID,com.exoscale.sdk.model.ResizeInstanceDiskRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api resize-instance-disk`

## <span data-label="DELETE" class="pill-DELETE"></span>reset-instance-field

Reset Instance field

```
DELETE /instance/{id}/{field}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |
| `field` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reset-instance-field`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetInstanceField) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_instance_field) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetInstanceField(java.util.UUID,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reset-instance-field`

## <span data-label="POST" class="pill-POST"></span>revert-instance-to-snapshot

Revert a snapshot for an instance

```
POST /instance/{instance-id}:revert-snapshot
```

This operation reverts the snapshot to the Compute instance volume, restoring stored data as it was at the time of the snapshot.
The Compute instance must be previously stopped.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `instance-id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `id` | string | **yes** | Snapshot ID<br/><br/>Must be a valid UUID. |

<details>
<summary>Example</summary>

```json
{
  "id": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `revert-instance-to-snapshot`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.RevertInstanceToSnapshot) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.revert_instance_to_snapshot) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#revertInstanceToSnapshot(java.util.UUID,com.exoscale.sdk.model.RevertInstanceToSnapshotRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api revert-instance-to-snapshot`

## <span data-label="GET" class="pill-GET"></span>list-instances

List Compute instances

```
GET /instance
```

### Query parameters

| Name | In | Required | Description |
| --- | --- | --- | --- |
| `manager-id` | `query` | no | Must be a valid UUID. |
| `manager-type` | `query` | no |  |
| `ip-address` | `query` | no |  |
| `labels` | `query` | no |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `instances` | array of [Instances](#instances) |  |

<details>
<summary>Example output</summary>

```json
{
  "instances": [
    {
      "created-at": "2024-01-01T12:00:00Z",
      "id": "string",
      "instance-type": {
        "authorized": true,
        "cpus": 0,
        "family": "gpu3",
        "gpus": 0,
        "id": "string",
        "memory": 0,
        "size": "large",
        "zones": [
          "ch-dk-2"
        ]
      },
      "ipv6-address": "string",
      "labels": {},
      "mac-address": "string",
      "manager": {
        "id": "string",
        "type": "sks-nodepool"
      },
      "name": "string",
      "private-networks": [
        {
          "id": "string",
          "mac-address": "string"
        }
      ],
      "public-ip": "string",
      "public-ip-assignment": "inet4",
      "security-groups": [
        {
          "description": "string",
          "external-sources": [
            null
          ],
          "id": "string",
          "name": "string",
          "rules": [
            null
          ]
        }
      ],
      "ssh-key": {
        "fingerprint": "string",
        "name": "string"
      },
      "ssh-keys": [
        {
          "fingerprint": "string",
          "name": "string"
        }
      ],
      "state": "expunging",
      "template": {
        "application-consistent-snapshot-enabled": true,
        "boot-mode": "legacy",
        "build": "string",
        "checksum": "string",
        "created-at": "2024-01-01T12:00:00Z",
        "default-user": "string",
        "description": "string",
        "family": "string",
        "id": "string",
        "maintainer": "string",
        "name": "string",
        "password-enabled": true,
        "size": 0,
        "ssh-key-enabled": true,
        "url": "string",
        "version": "string",
        "visibility": "private"
      }
    }
  ]
}
```
</details>


### Instances {#instances}

Instance

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `created-at` | string | no | Instance creation date<br/><br/>ISO 8601 date-time. |
| `id` | string | no | Instance ID<br/><br/>Must be a valid UUID. |
| `instance-type` | [Compute instance type](https://community.exoscale.com/reference/api/_schemas/instance-type/index.md) | no | Instance Type |
| `ipv6-address` | string | no | Instance IPv6 address |
| `labels` | object | no | Resource labels |
| `mac-address` | string | no | Instance MAC address |
| `manager` | [Resource manager](https://community.exoscale.com/reference/api/_schemas/manager/index.md) | no | Instance manager |
| `name` | string | no | Instance name<br/><br/>Min length: `1`. Max length: `255`. |
| `private-networks` | array of [Private Networks](#private-networks) | no | Instance Private Networks |
| `public-ip` | string | no | Instance public IPv4 address<br/><br/>Must be a valid IPv4 address. |
| `public-ip-assignment` | string | no | Instance public IP assignment<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `security-groups` | array of [Security Group](https://community.exoscale.com/reference/api/_schemas/security-group/index.md) | no | Instance Security Groups |
| `ssh-key` | [SSH key](https://community.exoscale.com/reference/api/_schemas/ssh-key/index.md) | no | Instance SSH Key |
| `ssh-keys` | array of [SSH key](https://community.exoscale.com/reference/api/_schemas/ssh-key/index.md) | no | Instance SSH Keys |
| `state` | string | no | Instance state<br/><br/>Allowed values: `expunging`, `starting`, `destroying`, `running`, `stopping`, `stopped`, `migrating`, `error`, `destroyed`. |
| `template` | [Instance template](https://community.exoscale.com/reference/api/_schemas/template/index.md) | no | Instance Template |

### Private Networks {#private-networks}

Private Network

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `id` | string | no | Private Network ID<br/><br/>Must be a valid UUID. |
| `mac-address` | string | no | Private Network MAC address |

SDK reference for `list-instances`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListInstances) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_instances) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listInstances(java.util.UUID,java.lang.String,java.lang.String,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api list-instances`

## <span data-label="POST" class="pill-POST"></span>create-snapshot

Create a Snapshot of a Compute instance

```
POST /instance/{id}:create-snapshot
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-snapshot`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateSnapshot) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_snapshot) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createSnapshot(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api create-snapshot`

## <span data-label="POST" class="pill-POST"></span>enable-tpm

Enable tpm for the instance.

```
POST /instance/{id}:enable-tpm
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `enable-tpm`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.EnableTpm) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.enable_tpm) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#enableTpm(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api enable-tpm`

---

url: https://community.exoscale.com/reference/api/compute/instance-pool/

---

# Instance Pool

<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Instance Pools is an Exoscale service allowing users to provision managed groups of identical Compute instances automatically.

[Read more](https://community.exoscale.com/product/compute/instances/how-to/instance-pools/index.md)

## <span data-label="POST" class="pill-POST"></span>create-instance-pool

Create an Instance Pool

```
POST /instance-pool
```

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `disk-size` | integer | **yes** | Instances disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `instance-type` | [Instance type reference](https://community.exoscale.com/reference/api/_schemas/instance-type-ref/index.md) | **yes** | Instances type |
| `name` | string | **yes** | Instance Pool name<br/><br/>Min length: `1`. Max length: `255`. |
| `size` | integer | **yes** | Number of Instances<br/><br/>Min: `0`. |
| `template` | [Template reference](https://community.exoscale.com/reference/api/_schemas/template-ref/index.md) | **yes** | Instances template |
| `anti-affinity-groups` | array of [Anti-affinity group reference](https://community.exoscale.com/reference/api/_schemas/anti-affinity-group-ref/index.md) | no | Instance Pool Anti-affinity Groups |
| `application-consistent-snapshot-enabled` | boolean | no | Enable application consistent snapshots |
| `deploy-target` | [Deploy target reference](https://community.exoscale.com/reference/api/_schemas/deploy-target-ref/index.md) | no | Deploy Target to deploy Instances on |
| `description` | string | no | Instance Pool description<br/><br/>Max length: `255`. |
| `elastic-ips` | array of [Elastic IP reference](https://community.exoscale.com/reference/api/_schemas/elastic-ip-ref/index.md) | no | Instances Elastic IPs |
| `instance-prefix` | string | no | Prefix to apply to Instances names (default: pool)<br/><br/>Min length: `1`. Max length: `30`. |
| `ipv6-enabled` | boolean | no | Enable IPv6. DEPRECATED: use `public-ip-assignments`. |
| `labels` | object | no | Instance Pool Labels |
| `min-available` | integer | no | Minimum number of running Instances<br/><br/>Min: `0`. |
| `private-networks` | array of [Private network reference](https://community.exoscale.com/reference/api/_schemas/private-network-ref/index.md) | no | Instance Pool Private Networks |
| `public-ip-assignment` | string | no | Determines public IP assignment of the Instances. Type `none` is final and can't be changed later on.<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `security-groups` | array of [Security group reference](https://community.exoscale.com/reference/api/_schemas/security-group-ref/index.md) | no | Instance Pool Security Groups |
| `ssh-key` | [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instances SSH key |
| `ssh-keys` | array of [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instances SSH Keys |
| `user-data` | string | no | Instances Cloud-init user-data<br/><br/>Min length: `1`. Max length: `32768`. |

<details>
<summary>Example</summary>

```json
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "ipv6-enabled": true,
  "labels": {},
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "size": 0,
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "template": {
    "id": "string"
  },
  "user-data": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `create-instance-pool`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.CreateInstancePool) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.create_instance_pool) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#createInstancePool(com.exoscale.sdk.model.CreateInstancePoolRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api create-instance-pool`

## <span data-label="GET" class="pill-GET"></span>get-instance-pool

Retrieve Instance Pool details

```
GET /instance-pool/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `anti-affinity-groups` | array of [Anti-affinity group reference](https://community.exoscale.com/reference/api/_schemas/anti-affinity-group-ref/index.md) | Instance Pool Anti-affinity Groups |
| `application-consistent-snapshot-enabled` | boolean | Enable application consistent snapshots |
| `deploy-target` | [Deploy target reference](https://community.exoscale.com/reference/api/_schemas/deploy-target-ref/index.md) | Instance Pool Deploy Target |
| `description` | string | Instance Pool description<br/><br/>Min length: `1`. Max length: `255`. |
| `disk-size` | integer | Instances disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `elastic-ips` | array of [Elastic IP reference](https://community.exoscale.com/reference/api/_schemas/elastic-ip-ref/index.md) | Instances Elastic IPs |
| `error-reason` | [Error Reason](https://community.exoscale.com/reference/api/_schemas/instance-pool/index.md#error-reason) | Instance Pool Error Reason |
| `id` | string | Instance Pool ID<br/><br/>Must be a valid UUID. |
| `instance-prefix` | string | The instances created by the Instance Pool will be prefixed with this value (default: pool)<br/><br/>Min length: `1`. Max length: `30`. |
| `instance-type` | [Instance type reference](https://community.exoscale.com/reference/api/_schemas/instance-type-ref/index.md) | Instances type |
| `instances` | array of [Target Instance](https://community.exoscale.com/reference/api/_schemas/instance-ref/index.md) | Instances |
| `ipv6-enabled` | boolean | Enable IPv6 for instances |
| `labels` | object | Instance Pool Labels |
| `manager` | [Resource manager](https://community.exoscale.com/reference/api/_schemas/manager/index.md) | Instance Pool manager |
| `min-available` | integer | Minimum number of running instances<br/><br/>Min: `0`. |
| `name` | string | Instance Pool name<br/><br/>Min length: `1`. Max length: `255`. |
| `private-networks` | array of [Private network reference](https://community.exoscale.com/reference/api/_schemas/private-network-ref/index.md) | Instance Pool Private Networks |
| `public-ip-assignment` | string | Instance Pool public IP assignment<br/><br/>Allowed values: `inet4`, `dual`, `none`. |
| `security-groups` | array of [Security group reference](https://community.exoscale.com/reference/api/_schemas/security-group-ref/index.md) | Instance Pool Security Groups |
| `size` | integer | Number of instances<br/><br/>Min: `0`. |
| `ssh-key` | [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | Instances SSH key |
| `ssh-keys` | array of [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | Instances SSH keys |
| `state` | string | Instance Pool state<br/><br/>Allowed values: `scaling-up`, `scaling-down`, `destroying`, `creating`, `suspended`, `running`, `updating`, `error`. |
| `template` | [Template reference](https://community.exoscale.com/reference/api/_schemas/template-ref/index.md) | Instances template |
| `user-data` | string | Instances Cloud-init user-data<br/><br/>Min length: `1`. |

<details>
<summary>Example output</summary>

```json
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "error-reason": {
    "cause": "string",
    "job-id": "string",
    "type": "string"
  },
  "id": "string",
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "instances": [
    {
      "id": "string"
    }
  ],
  "ipv6-enabled": true,
  "labels": {},
  "manager": {
    "id": "string",
    "type": "sks-nodepool"
  },
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "size": 0,
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "state": "scaling-up",
  "template": {
    "id": "string"
  },
  "user-data": "string"
}
```
</details>


SDK reference for `get-instance-pool`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetInstancePool) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_instance_pool) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getInstancePool(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api get-instance-pool`

## <span data-label="PUT" class="pill-PUT"></span>scale-instance-pool

Scale an Instance Pool

```
PUT /instance-pool/{id}:scale
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `size` | integer | **yes** | Number of managed Instances<br/><br/>Min: `0`. |

<details>
<summary>Example</summary>

```json
{
  "size": 0
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `scale-instance-pool`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ScaleInstancePool) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.scale_instance_pool) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#scaleInstancePool(java.util.UUID,com.exoscale.sdk.model.ScaleInstancePoolRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api scale-instance-pool`

## <span data-label="PUT" class="pill-PUT"></span>update-instance-pool

Update an Instance Pool

```
PUT /instance-pool/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `anti-affinity-groups` | array of [Anti-affinity group reference](https://community.exoscale.com/reference/api/_schemas/anti-affinity-group-ref/index.md) | no | Instance Pool Anti-affinity Groups |
| `application-consistent-snapshot-enabled` | boolean | no | Enable application consistent snapshots |
| `deploy-target` | [Deploy target reference](https://community.exoscale.com/reference/api/_schemas/deploy-target-ref/index.md) | no | Instance Pool Deploy Target |
| `description` | string | no | Instance Pool description<br/><br/>Max length: `255`. |
| `disk-size` | integer | no | Instances disk size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `elastic-ips` | array of [Elastic IP reference](https://community.exoscale.com/reference/api/_schemas/elastic-ip-ref/index.md) | no | Instances Elastic IPs |
| `instance-prefix` | string | no | Prefix to apply to Instances names (default: pool) |
| `instance-type` | [Instance type reference](https://community.exoscale.com/reference/api/_schemas/instance-type-ref/index.md) | no | Instances type |
| `ipv6-enabled` | boolean | no | Enable IPv6. DEPRECATED: use `public-ip-assignments`. |
| `labels` | object | no | Instance Pool Labels |
| `min-available` | integer | no | Minimum number of running Instances<br/><br/>Min: `0`. |
| `name` | string | no | Instance Pool name<br/><br/>Min length: `1`. Max length: `255`. |
| `private-networks` | array of [Private network reference](https://community.exoscale.com/reference/api/_schemas/private-network-ref/index.md) | no | Instance Pool Private Networks |
| `public-ip-assignment` | string | no | Determines public IP assignment of the Instances.<br/><br/>Allowed values: `inet4`, `dual`. |
| `security-groups` | array of [Security group reference](https://community.exoscale.com/reference/api/_schemas/security-group-ref/index.md) | no | Instance Pool Security Groups |
| `ssh-key` | [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instances SSH key |
| `ssh-keys` | array of [SSH key reference](https://community.exoscale.com/reference/api/_schemas/ssh-key-ref/index.md) | no | Instances SSH keys |
| `template` | [Template reference](https://community.exoscale.com/reference/api/_schemas/template-ref/index.md) | no | Instances template |
| `user-data` | string | no | Instances Cloud-init user-data<br/><br/>Min length: `1`. |

<details>
<summary>Example</summary>

```json
{
  "anti-affinity-groups": [
    {
      "id": "string"
    }
  ],
  "application-consistent-snapshot-enabled": true,
  "deploy-target": {
    "id": "string"
  },
  "description": "string",
  "disk-size": 0,
  "elastic-ips": [
    {
      "id": "string"
    }
  ],
  "instance-prefix": "string",
  "instance-type": {
    "id": "string"
  },
  "ipv6-enabled": true,
  "labels": {},
  "min-available": 0,
  "name": "string",
  "private-networks": [
    {
      "id": "string"
    }
  ],
  "public-ip-assignment": "inet4",
  "security-groups": [
    {
      "id": "string"
    }
  ],
  "ssh-key": {
    "name": "string"
  },
  "ssh-keys": [
    {
      "name": "string"
    }
  ],
  "template": {
    "id": "string"
  },
  "user-data": "string"
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `update-instance-pool`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.UpdateInstancePool) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.update_instance_pool) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#updateInstancePool(java.util.UUID,com.exoscale.sdk.model.UpdateInstancePoolRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api update-instance-pool`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-instance-pool

Delete an Instance Pool

```
DELETE /instance-pool/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-instance-pool`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteInstancePool) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_instance_pool) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteInstancePool(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api delete-instance-pool`


---

## Other Operations

## <span data-label="PUT" class="pill-PUT"></span>evict-instance-pool-members

Evict Instance Pool members

```
PUT /instance-pool/{id}:evict
```

This operation evicts the specified Compute instances member from the Instance Pool, shrinking it to `&lt;current pool size&gt; - &lt;# evicted members&gt;`.

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `instances` | array[string] | no |  |

<details>
<summary>Example</summary>

```json
{
  "instances": [
    "string"
  ]
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `evict-instance-pool-members`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.EvictInstancePoolMembers) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.evict_instance_pool_members) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#evictInstancePoolMembers(java.util.UUID,com.exoscale.sdk.model.EvictInstancePoolMembersRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api evict-instance-pool-members`

## <span data-label="DELETE" class="pill-DELETE"></span>reset-instance-pool-field

Reset an Instance Pool field to its default value

```
DELETE /instance-pool/{id}/{field}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |
| `field` | `path` |  |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `reset-instance-pool-field`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ResetInstancePoolField) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.reset_instance_pool_field) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#resetInstancePoolField(java.util.UUID,java.lang.String))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api reset-instance-pool-field`

## <span data-label="GET" class="pill-GET"></span>list-instance-pools

List Instance Pools

```
GET /instance-pool
```

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `instance-pools` | array of [Instance Pool](https://community.exoscale.com/reference/api/_schemas/instance-pool/index.md) |  |

<details>
<summary>Example output</summary>

```json
{
  "instance-pools": [
    {
      "anti-affinity-groups": [
        {
          "id": "string"
        }
      ],
      "application-consistent-snapshot-enabled": true,
      "deploy-target": {
        "id": "string"
      },
      "description": "string",
      "disk-size": 0,
      "elastic-ips": [
        {
          "id": "string"
        }
      ],
      "error-reason": {
        "cause": "string",
        "job-id": "string",
        "type": "string"
      },
      "id": "string",
      "instance-prefix": "string",
      "instance-type": {
        "id": "string"
      },
      "instances": [
        {
          "id": "string"
        }
      ],
      "ipv6-enabled": true,
      "labels": {},
      "manager": {
        "id": "string",
        "type": "sks-nodepool"
      },
      "min-available": 0,
      "name": "string",
      "private-networks": [
        {
          "id": "string"
        }
      ],
      "public-ip-assignment": "inet4",
      "security-groups": [
        {
          "id": "string"
        }
      ],
      "size": 0,
      "ssh-key": {
        "name": "string"
      },
      "ssh-keys": [
        {
          "name": "string"
        }
      ],
      "state": "scaling-up",
      "template": {
        "id": "string"
      },
      "user-data": "string"
    }
  ]
}
```
</details>


SDK reference for `list-instance-pools`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListInstancePools) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_instance_pools) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listInstancePools())

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api list-instance-pools`

---

url: https://community.exoscale.com/reference/api/compute/snapshot/

---

# Snapshot

<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Snapshots provide a way to get point-in-time recovery for your Compute instance.

[Read more](https://community.exoscale.com/product/compute/instances/how-to/snapshot/index.md)

## <span data-label="GET" class="pill-GET"></span>get-snapshot

Retrieve Snapshot details

```
GET /snapshot/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `application-consistent` | boolean | Indicates whether the snapshot was taken using an application-consistent method |
| `created-at` | string | Snapshot creation date<br/><br/>ISO 8601 date-time. |
| `export` | [Export](https://community.exoscale.com/reference/api/_schemas/snapshot/index.md#export) | Exported snapshot information |
| `id` | string | Snapshot ID<br/><br/>Must be a valid UUID. |
| `instance` | [Instance](https://community.exoscale.com/reference/api/_schemas/instance/index.md) | Compute Instance snapshotted |
| `name` | string | Snapshot name<br/><br/>Min length: `1`. Max length: `255`. |
| `size` | integer | Snapshot size in GiB<br/><br/>Min: `10`. Max: `51200`. |
| `state` | string | Snapshot state<br/><br/>Allowed values: `snapshotting`, `deleted`, `exporting`, `ready`, `deleting`, `error`, `exported`. |

<details>
<summary>Example output</summary>

```json
{
  "application-consistent": true,
  "created-at": "2024-01-01T12:00:00Z",
  "export": {
    "md5sum": "string",
    "presigned-url": "string"
  },
  "id": "string",
  "instance": {
    "anti-affinity-groups": [
      {
        "id": "string"
      }
    ],
    "application-consistent-snapshot-enabled": true,
    "created-at": "2024-01-01T12:00:00Z",
    "deploy-target": {
      "id": "string"
    },
    "disk-encrypted": true,
    "disk-size": 0,
    "elastic-ips": [
      {
        "id": "string"
      }
    ],
    "id": "string",
    "instance-type": {
      "authorized": true,
      "cpus": 0,
      "family": "gpu3",
      "gpus": 0,
      "id": "string",
      "memory": 0,
      "size": "large",
      "zones": [
        "ch-dk-2"
      ]
    },
    "ip-forwarding": true,
    "ipv6-address": "string",
    "labels": {},
    "mac-address": "string",
    "manager": {
      "id": "string",
      "type": "sks-nodepool"
    },
    "name": "string",
    "private-networks": [
      {
        "id": "string",
        "mac-address": "string"
      }
    ],
    "public-ip": "string",
    "public-ip-assignment": "inet4",
    "secureboot-enabled": true,
    "security-groups": [
      {
        "id": "string"
      }
    ],
    "snapshots": [
      {
        "id": "string"
      }
    ],
    "ssh-key": {
      "fingerprint": "string",
      "name": "string"
    },
    "ssh-keys": [
      {
        "fingerprint": "string",
        "name": "string"
      }
    ],
    "state": "expunging",
    "template": {
      "application-consistent-snapshot-enabled": true,
      "boot-mode": "legacy",
      "build": "string",
      "checksum": "string",
      "created-at": "2024-01-01T12:00:00Z",
      "default-user": "string",
      "description": "string",
      "family": "string",
      "id": "string",
      "maintainer": "string",
      "name": "string",
      "password-enabled": true,
      "size": 0,
      "ssh-key-enabled": true,
      "url": "string",
      "version": "string",
      "visibility": "private"
    },
    "tpm-enabled": true,
    "user-data": "string",
    "vpc": {
      "id": "string",
      "name": "string",
      "subnets": [
        {
          "id": "string",
          "ipv4": "string",
          "name": "string"
        }
      ]
    }
  },
  "name": "string",
  "size": 0,
  "state": "snapshotting"
}
```
</details>


SDK reference for `get-snapshot`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.GetSnapshot) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.get_snapshot) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#getSnapshot(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api get-snapshot`

## <span data-label="DELETE" class="pill-DELETE"></span>delete-snapshot

Delete a Snapshot

```
DELETE /snapshot/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `delete-snapshot`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.DeleteSnapshot) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.delete_snapshot) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#deleteSnapshot(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api delete-snapshot`


---

## Other Operations

## <span data-label="POST" class="pill-POST"></span>export-snapshot

Export a Snapshot

```
POST /snapshot/{id}:export
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `export-snapshot`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ExportSnapshot) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.export_snapshot) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#exportSnapshot(java.util.UUID))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api export-snapshot`

## <span data-label="POST" class="pill-POST"></span>promote-snapshot-to-template

Promote a Snapshot to a Template

```
POST /snapshot/{id}:promote
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Request body

Content-Type: `application/json`

| Property | Type | Required | Description |
| --- | --- | --- | --- |
| `name` | string | **yes** | Template name<br/><br/>Min length: `1`. Max length: `255`. |
| `default-user` | string | no | Template default user<br/><br/>Min length: `1`. Max length: `255`. |
| `description` | string | no | Template description<br/><br/>Max length: `4096`. |
| `password-enabled` | boolean | no | Enable password-based login in the template |
| `ssh-key-enabled` | boolean | no | Enable SSH key-based login in the template |

<details>
<summary>Example</summary>

```json
{
  "default-user": "string",
  "description": "string",
  "name": "string",
  "password-enabled": true,
  "ssh-key-enabled": true
}
```
</details>


### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `id` | string | Operation ID<br/><br/>Must be a valid UUID. |
| `message` | string | Operation message |
| `reason` | string | Operation failure reason<br/><br/>Allowed values: `incorrect`, `unknown`, `unavailable`, `forbidden`, `busy`, `fault`, `partial`, `not-found`, `interrupted`, `unsupported`, `conflict`. |
| `reference` | [Reference](https://community.exoscale.com/reference/api/_schemas/operation/index.md#reference) | Related resource reference |
| `state` | string | Operation status<br/><br/>Allowed values: `failure`, `pending`, `success`, `timeout`. |

<details>
<summary>Example output</summary>

```json
{
  "id": "string",
  "message": "string",
  "reason": "incorrect",
  "reference": {
    "command": "string",
    "id": "string",
    "link": "string"
  },
  "state": "failure"
}
```
</details>


SDK reference for `promote-snapshot-to-template`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.PromoteSnapshotToTemplate) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.promote_snapshot_to_template) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#promoteSnapshotToTemplate(java.util.UUID,com.exoscale.sdk.model.PromoteSnapshotToTemplateRequest))

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api promote-snapshot-to-template`

## <span data-label="GET" class="pill-GET"></span>list-snapshots

List Snapshots

```
GET /snapshot
```

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `snapshots` | array of [Snapshot](https://community.exoscale.com/reference/api/_schemas/snapshot/index.md) |  |

<details>
<summary>Example output</summary>

```json
{
  "snapshots": [
    {
      "application-consistent": true,
      "created-at": "2024-01-01T12:00:00Z",
      "export": {
        "md5sum": "string",
        "presigned-url": "string"
      },
      "id": "string",
      "instance": {
        "anti-affinity-groups": [
          {
            "id": null
          }
        ],
        "application-consistent-snapshot-enabled": true,
        "created-at": "2024-01-01T12:00:00Z",
        "deploy-target": {
          "id": "string"
        },
        "disk-encrypted": true,
        "disk-size": 0,
        "elastic-ips": [
          {
            "id": null
          }
        ],
        "id": "string",
        "instance-type": {
          "authorized": true,
          "cpus": 0,
          "family": "gpu3",
          "gpus": 0,
          "id": "string",
          "memory": 0,
          "size": "large",
          "zones": [
            null
          ]
        },
        "ip-forwarding": true,
        "ipv6-address": "string",
        "labels": {},
        "mac-address": "string",
        "manager": {
          "id": "string",
          "type": "sks-nodepool"
        },
        "name": "string",
        "private-networks": [
          {
            "id": null,
            "mac-address": null
          }
        ],
        "public-ip": "string",
        "public-ip-assignment": "inet4",
        "secureboot-enabled": true,
        "security-groups": [
          {
            "id": null
          }
        ],
        "snapshots": [
          {
            "id": null
          }
        ],
        "ssh-key": {
          "fingerprint": "string",
          "name": "string"
        },
        "ssh-keys": [
          {
            "fingerprint": null,
            "name": null
          }
        ],
        "state": "expunging",
        "template": {
          "application-consistent-snapshot-enabled": true,
          "boot-mode": "legacy",
          "build": "string",
          "checksum": "string",
          "created-at": "2024-01-01T12:00:00Z",
          "default-user": "string",
          "description": "string",
          "family": "string",
          "id": "string",
          "maintainer": "string",
          "name": "string",
          "password-enabled": true,
          "size": 0,
          "ssh-key-enabled": true,
          "url": "string",
          "version": "string",
          "visibility": "private"
        },
        "tpm-enabled": true,
        "user-data": "string",
        "vpc": {
          "id": "string",
          "name": "string",
          "subnets": [
            null
          ]
        }
      },
      "name": "string",
      "size": 0,
      "state": "snapshotting"
    }
  ]
}
```
</details>


SDK reference for `list-snapshots`: [golang](https://pkg.go.dev/github.com/exoscale/egoscale/v3#Client.ListSnapshots) | [Python](https://exoscale.github.io/python-exoscale/v2.html#exoscale.api.v2.Client.list_snapshots) | [Java](https://exoscale.github.io/exoscale-sdk-java/com/exoscale/sdk/api/ExoscaleApi.html#listSnapshots())

[CLI](https://community.exoscale.com/tools/command-line-interface/index.md): `exo api list-snapshots`

---

url: https://community.exoscale.com/reference/api/compute/template/

---

# Template

<style>
  span[class^="pill-"] {
    color: white;
    padding: 2px 12px;
    border-radius: 12px;
    font-size: 0.6em;
    vertical-align: middle;
    margin-right: 12px;
    font-family: sans-serif;
    font-weight: bold;
    display: inline-block;
    line-height: 1;
  }
  span.pill-GET { background-color: #61affe; }
  span.pill-POST { background-color: #49cc90; }
  span.pill-PUT { background-color: #fca130; }
  span.pill-DELETE { background-color: #f93e3e; }
  span.pill-PATCH { background-color: #50e3c2; }
  span[class^="pill-"]:after {
    content: attr(data-label);
    font-size: 0.9rem;
  }
</style>

Templates contain the OS and the initial setup of a Compute instance.

[Read more](https://www.exoscale.com/templates/)

## <span data-label="GET" class="pill-GET"></span>get-template

Retrieve Template details

```
GET /template/{id}
```

### Path parameters

| Name | In | Description |
| --- | --- | --- |
| `id` | `path` | Must be a valid UUID. |

### Responses

Status: `200` - 200

Content-Type: `application/json`

| Property | Type | Description |
| --- | --- | --- |
| `application-consistent-snapshot-enabled` | boolean | Template with Qemu Guest Agent installed for application consistent snapshot |
| `boot-mode` | string | Boot mode (default: legacy)<br/><br/>Allowed values: `legacy`, `uefi`. |
| `build` | string | Template build |
| `checksum` | string | Template MD5 checksum |
| `created-at` | string | Template creation date<br/><br/>ISO 8601 date-time. |
| `default-user` | string | Template default user<br/><br/>Min length: `1`. Max length: `255`. |
| `description` | string | Template description<br/><br/>Max length: `255`. |
| `family` | string | Template family |
| `id` | string | Template ID<br/><br/>Must be a valid UUID. |
| `maintainer` | string | Template maintainer |
| `name` | string | Template name<br/><br/>Min length: `1`. Max length: `255`. |
| `password-enabled` | boolean | Enable password-based login |
| `size` | integer | Template size<br/><br/>Min: `0`. |
| `ssh-key-enabled` | boolean | Enable SSH key-based login |
| `url` | string | Template source URL |
| `version` | string | Template version |
| `visibility` | string | Template visibility<br/><br/>Allowed values: `private`, `public`. |

<details>
<summary>Example output</summary>

```json
{
  "application-consistent-snapshot-enabled": true,
  "boot-mode": "legacy",
  "build": "string",
  "checksum": "string",
  "created-at": "2024-01-01T12:00:00Z",
  "default-user": "string",
  "description": "string",
  "family": "string",
  "id": "string",
  "maintainer": "string",
  "name": "string",
  "password-enabled": true,
  "size": 0,
  "ssh-key-enabled": true,
  "url": "string",
  "version": "string",
  "visibility": "private"
}
```
</details>


[...]
